#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi (Windows Hosts Only)

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

$use_ppc_plugin = 1;   ## <-- DON'T CHANGE THIS SETTING UNLESS YOU OWN THIS PLUGIN


#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin; 

use CGI::Carp qw(fatalsToBrowser);
use CGI qw(param);
use DBI;
use ppc_ps;
use URI::Escape;
use fmspm;
use scloud;

$default_permissions = 0777;

use ps_ppc;
#use strict;
#use Benchmark;
#use Time::HiRes;


my ($mysql_hostname, $dsn, $db_name, $db_username, $db_password, $mysql_hostname, $mysql_port, $script_url,
	$admin_url, $web_url, $web_dir, $data_dir, $username, $password, $dbh, $original_keywords, $pages_prev,
	$pages_next, $gsettings, $keywords, $crit, $q, $search_templat, $search_links, $addurl, 
	$sec, $min, $hour, $mday, $mon, $year, $wday, $ydat, $isdst, $sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst,
	$serror, $sth, $sql, $cat_search, $cat_search, @all_cts, $lvc, $catsql, $citem, $citem, $keydata, 
	@akeys, $knr, $keyname, $visible, $size, $searched, $description, $imgk, $nmbr, $kitem, $mtime, $cat_search_orig, 
	$na, $specdir_sql, @tmp_keyw, $kwc, $kwitem, @tmp_keyw, @allkeywords, $where_sql, $tmp_specdir_sql, 
	$where_sql, $rows, $nr_searchres, $modp, $icnt, $pages, $st, $nd, $main_nd, $main_st, @row, $score, $titlescore,
	$dizscore, $keywordscore, $urlscore, $exrafk_pos, $high_number, $writecrit, $extrk_score,
	$ms3, @results_array, $rs_cnt, $all_links, $ms, $pg, $cnposition, $hiddenstr, $pgstring, $searched_item,
	$ippc, $currentpage, $prev_ppos, $staticpos, $pvst, $pvnd, $next_ppos, $staticpos, $next_ppos, $spls, 
	$nextt, $nd1, $st1, $prev, $spcer,$prevnext, $myspacer, $new_win_crit, $title_with_link,
	$reald, $nrc, $reviews, $reviews, $modifyl, $rptdl, $rateit, $rating_image, $time1, 
	$time2, $time3, $cats, $ecat, $rdcat, @acts, $lv, $from_category, $perc, $rgraphic, $fext, $keyitem, $rowcntr,
	$imgcrit, $phrase_scr, $wholeword_scr, $partialword_scr); 

&get_setup;
fmspm::check_spamb("search.cgi", "header", "$data_dir");
$q = CGI->new;

#### SEARCH CONFIGURATION ########################################

$SQLSearch_Method = "STANDARD_SQL_PW"; ### STANDARD SQL WITH PARTIAL WORD MATCHING
#$SQLSearch_Method = "STANDARD_SQL"; ### STANDARD SQL
#$SQLSearch_Method = "REGEXPR"; ### REGULAR MYSQL EXPRESSIONS

$minimum_keyword_length = "2"; ## ( HAS TO BE AT LEAST THIS NUMBER OF CHARACTERS BEFORE A SEARCH IS PERFORMED

$pages_prev = "3"; ### PAGES TO LIST ON PAGE (TO THE LEFT)
$pages_next = "3"; ### PAGES TO LIST ON PAGE (TO THE RIGHT)

#### SEARCH SCORING ###############################################
#
# Each Matched Link is first loosely matched with a MySQL SELECT statement.
# After this each link is asigned a score by the kind of matches 
# that took place. After each link has a score, the links are sorted
# from most to least score.
#

$debug_scores = "N"; ## Y = Display scores for matches / N = do not display scores for matches

### SCORING FOR TITLES
$t_phrase_match_score = 200;
$t_whole_word_match_score = 30;
$t_partial_match_score = 3;

### SCORING FOR DESCRIPTIONS
$d_phrase_match_score = 80;
$d_whole_word_match_score = 10;
$d_partial_match_score = 2;

### SCORING FOR KEYWORDS
$k_phrase_match_score = 60;
$k_whole_word_match_score = 10;
$k_partial_match_score = 3;

### SCORING FOR EXTRA FIELDS/KEYS
$e_phrase_match_score = 70;
$e_whole_word_match_score = 7;
$e_partial_match_score = 2;

### AND MATCHING (INCREASES RELEVANCE) - OR MATCHING ARE DONE BY DEFAULT
# Only used if more than one keyword is specified to search for
# Below is the score to add for each instance where both keywords
# are available in the listing

$and_match_score_adding = 100;


##### END OF CONIGURATION #######################################



print "Content-type: text/html\n\n";

my $today_time = time();
$keywords = $q->param('keywords');
$escaped_keywords = quotemeta($keywords);

$passon_keywords = uri_escape($keywords);;

$gsettings = &new_gsettings;

### CHECK SEARCH SPAMMING
if (($gsettings->{searches_per_hour} > 0) and ($q->param('st') eq "") and ($q->param('nd') eq ""))
	{
	&check_search_spamming;
	}


### UPDATE SEARCH CLOUD IF NEEDED

$search_cloud_details = &get_file_contents("$data_dir/scloud1.dat");
($logging) = split (/\t/, $search_cloud_details);
if ($logging eq "Yes") { scloud::do_search_cloud($search_cloud_details, "$script_url/search.cgi", $data_dir, $web_dir); }



### IF FULL TEXT SEARCHING IS IN USE
if (($gsettings->{searchmeth} eq "fulltext") and ($q->param('fct') ne "advanced")){&do_full_text_search; exit;}


### FLOOD CONTROL



if (($gsettings->{floodcontrol} eq "Yes") or ($gsettings->{floodcontrol} eq ""))
	{
	$secswait = $gsettings->{flood_seconds};

	if ((-e "$data_dir/flcontrol") < 1)
		{
		mkdir ("$data_dir/flcontrol", 0777);
		$stat = chmod($default_permissions,"$data_dir/flcontrol","$data_dir/flcontrol");
		}

	$userip = $ENV{'REMOTE_ADDR'};

	if ($userip =~ /\//) { print "Invalid IP Address"; exit; }
	if ($userip =~ /\\/) { print "Invalid IP Address"; exit; }

	if (-e "$data_dir/flcontrol/$userip")
		{
		($device,$inode,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,
	    $mtime,$ctime,$blksize,$blocks) = stat("$data_dir/flcontrol/$userip");
	    #print "$atime - $mtime - $ctime :: $today_time<BR>";
	    #print $today_time - $mtime . "-- $secswait<BR><BR>";
    
    	$floodhtml = &get_file_contents("$data_dir/flood.html");
    	$floodhtml =~ s/!!web_url!!/$web_url/gi;


   
	   if (($today_time - $mtime) < 2)
	    	{
	    	
	    		if ($q->param('fct') eq "advanced")
	    			{
	    			$title = $q->param('title');
	    			$diz = $q->param('diz');
	    			$kw = $q->param('kw');
	    			$url = $q->param('url');
	    			$mtype = $q->param('mtype');
	    			$keywords = $keywords . "&title=$title&diz=$diz&kw=$kw&url=$url&fct=advanced&mtype=$mtype";
	    			
	    			#print "$keywords";
	    			}
	    		
	    		$cat_search = $q->param('cat_search');
	    		
	    	print qq[
	    	<html>
			<head>
			<title>Searching</title>
			<meta HTTP-EQUIV="REFRESH" CONTENT="$secswait;URL=$script_url/search.cgi?keywords=$keywords&cat_search=$cat_search">
			</head>
			<body>
			$floodhtml
			</body>
			</html>
			];
			exit;
	    	}
		open (IPF, "> $data_dir/flcontrol/$userip");
		close (IPF);
		}
		else
		{
		open (IPF, "> $data_dir/flcontrol/$userip");
		close (IPF);
		}
	}




if ($q->param('fct') eq "advanced") { $SQLSearch_Method = "STANDARD_SQL_PW"; }

if (length($keywords) < $minimum_keyword_length) {$original_keywords = "$keywords"; &use_nomatch_template;}


if ($keywords eq "") { &use_nomatch_template;}
if (length($keywords) > 40) { &use_nomatch_template;}


$crit = chr(93);
$keywords =~ s/$crit//gi;

### GET TEMPLATE

$search_templat = &get_file_contents("$data_dir/searchres.html");
$search_links = &get_file_contents("$data_dir/lsearchres_loc.html");
$search_links_prem = &get_file_contents("$data_dir/lsearchres_loc_prem.html");

$keywords9 = $keywords;
$keywords9 =~ s/</&lt;/g; $message =~ s/>/&gt;/g; 

$search_templat =~ s/%%keywords%%/$keywords9/g;
$search_templat =~ s/!!keywords!!/$keywords9/g;

$keywords_amazon = $keywords9;
$keywords_amazon =~ s/ /%20/gi;
$search_templat =~ s/!!keywords_amazon!!/$keywords_amazon/g;



$okeywords = $keywords;

$search_templat =~ s/!!scripts_url!!/$script_url/g;

$search_templat =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;

$search_templat =~ s/!build_url!/$web_url/g;
$search_templat =~ s/!!build_url!!/$web_url/g;

$addurl = "<a href=\"$script_url/addurl.cgi\">$gsettings->{add_url_link}</a>";
$search_templat =~ s/%%addurl%%/$addurl/g;



### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$original_keywords = $keywords;
$keywords =~ s/'/\\'/g;
$keywords =~ s/\\//g;


### LOG KEYWORDS

if ($gsettings->{log_search_keywords} eq "Yes")
{

	if (($q->param('st') eq "") and ($q->param('nd') eq "") and ($keywords ne "") and (substr($keywords, 0, 5) ne "link:"))
		{
		$search_log_details = &get_file_contents("$data_dir/searchlog.dat");
		($maxlen, $restrict) = split (/\n/, $search_log_details);
		

		if ($restrict eq "Yes")
			{
				for ($ms = 0; $ms < length($q->param('keywords')); $ms++) 
				{
				$oneletter = substr($q->param('keywords'), $ms, 1);
				if (($oneletter !~ /[0-9a-zA-Z]/) and ($oneletter ne " "))
					{
					$log_kw = "No";
					}
				} 
			}
		

		if (length($q->param('keywords')) > $maxlen)
			{
			$log_kw = "No";
			}

		
		if ($log_kw ne "No")
			{
			($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime();
			$year = $year + 1900;
			$mon++;
			$mtime = "$year-$mon-$mday"; 
			#$mtime = "2003-03-01"; 

			$keywords_ins = $keywords;
			$keywords_ins =~ s/'/\\'/g;

			$sql = "INSERT INTO keywlog SET kwdate = '$mtime', keyword = '$keywords_ins'";
			$sth = $dbh->prepare($sql);
			if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }
			$sth->execute;
			#$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
			}
	}
}


#### CHECK IF WE ARE GOING TO SEARCH A CERTAIN CATEGORY AND IF SO ADD IT TO SQL QUERY

$cat_search = $q->param('cat_search');
$cat_search_orig = $q->param('cat_search');

if (substr($q->param('cat_search'), 0, 4) eq "CST_")
	{
	$cat_search =~ s/CST_//g;
	
	@all_cts = split (/-/, $cat_search);
	
		$lvc = 1;
		$catsql = "AND (";
		foreach $citem (@all_cts)
			{
			$citem = &decode_dir($citem);
			$citem =~ s/'/\\'/g;
			$catsql = $catsql . " (B.l" . $lvc . "= '$citem') AND";
			$lvc++;
			}
		$catsql = substr($catsql, 0, length($catsql) - 3);
		$catsql = $catsql . ")";
	}



### GET EXTRA KEYS/FIELDS AND PREPARE SQL SO THAT THOSE ARE ALSO SEARCHED

$keydata = &get_file_contents("$data_dir/keys.dat");
$key_upload_data = &get_file_contents("$data_dir/keysupl.dat");
@upl_items = split (/:-o_:/, $key_upload_data); 


if (($keydata ne "") and (substr($keywords, 0, 5) ne "link:"))
{
	@akeys = split (/\n/, $keydata);
	$knr = @akeys;

	foreach $kitem (@akeys)
	{
	($keyname, $visible, $size, $searched, $description, $na, $imgk, $nmbr) = split (/\t/, $kitem);
	

		if ($q->param('fct')	eq "advanced") ### FOR ADVANCED SEARCHES
			{

			
				if (($q->param('mtype') eq "internal") and ($q->param($keyname) eq "$keyname"))
						{
						$specdir_sql = $specdir_sql . " (A." . $keyname . "_cust like '%KEYWORDS_HERE%') or";
						}
				elsif (($q->param('mtype') eq "andkeywords") and ($q->param($keyname) eq "$keyname"))
						{
						$specdir_sql = $specdir_sql . " (A." . $keyname . "_cust REGEXP '\[\[:<:\]\]KEYWORDS_HERE\[\[:>:\]\]') or";
						}
				elsif (($q->param('mtype') eq "phrase") and ($q->param($keyname) eq "$keyname"))
						{
						$specdir_sql = $specdir_sql . " (A." . $keyname . "_cust like '%$keywords%') or";
						}
				
				
				if ($q->param($keyname) eq $keyname)
					{
					$passon_crit = $passon_crit . "&" . $keyname . "=" . $keyname;
					}
					
				
			$knr2++;
			}
		elsif (($searched eq "Yes") and ($imgk ne "Yes") and ($nmbr ne "Y")) ### FOR NORMAL SEARCHES
			{
			
				if ($SQLSearch_Method eq "REGEXPR")
					{		
					$specdir_sql = $specdir_sql . " (A." . $keyname . "_cust REGEXP '\[\[:<:\]\]KEYWORDS_HERE\[\[:>:\]\]') or";
					}
					elsif ($SQLSearch_Method eq "STANDARD_SQL")
					{
					$specdir_sql = $specdir_sql . " (A." . $keyname . "_cust like '% KEYWORDS_HERE%') or";
					$specdir_sql = $specdir_sql . " (A." . $keyname . "_cust like '%KEYWORDS_HERE %') or";
					$specdir_sql = $specdir_sql . " (A." . $keyname . "_cust like '% KEYWORDS_HERE %') or";
					$specdir_sql = $specdir_sql . " (A." . $keyname . "_cust like 'KEYWORDS_HERE') or";
					}
					else
					{
					$specdir_sql = $specdir_sql . " (A." . $keyname . "_cust like '%KEYWORDS_HERE%') or";
					}
	
			$knr2++;
		  }
		
	}

}



### IF THIS IS AN ADVANCED SEARCH AND NO FIELDS WHERE SELECTED DISPLAY NOMATCH TEMPLATE
if (($q->param('fct') eq "advanced") and ($specdir_sql eq "") and ($q->param('title') ne "title") and 
($q->param('diz') ne "description") and ($q->param('kw') ne "keywords") and ($q->param('url') ne "url"))
{
&use_nomatch_template;
}




####### IF WE ARE SEARCHING FOR A URL, SET UP THE SEARCH
if (substr($keywords, 0, 5) eq "link:")
{
$SQLSearch_Method = "URL";
}


####### SPLIT KEYWORDS SO THAT WE CAN SEARCH FOR INDIVIDUAL KEYWORDS

if (($keywords =~ / /) and ($q->param('mtype') ne "phrase"))
	{
		@tmp_keyw = split (/ /, $keywords);
		$kwc = 0;
		foreach $kwitem (@tmp_keyw)
			{
			if (length($kwitem) > ($minimum_keyword_length - 1))
				{
				$allkeywords[$kwc] = $kwitem;
				
				$kesc = quotemeta($kwitem);
				$escaped_keywords_more[$kwc] = $kesc;
				$kwc++;
				}
			}



		###### BUILD SQL QUERY
		foreach $kwitem (@allkeywords)
			{
			$kwitem =~ s/'/\\'/g;

			if (($q->param('fct') eq "advanced") and ($q->param('mtype') eq "andkeywords")) ### ADVANCED SEARCH AND MATCHING
				{
				
					if ($q->param('title') eq "title") {$where_sql = $where_sql . "(A.title REGEXP '\[\[:<:\]\]$kwitem\[\[:>:\]\]') OR";}
					if ($q->param('diz') eq "description") {$where_sql = $where_sql . "(A.description REGEXP '\[\[:<:\]\]$kwitem\[\[:>:\]\]') OR";}
					if ($q->param('kw') eq "keywords") {$where_sql = $where_sql . "(A.keywords REGEXP '\[\[:<:\]\]$kwitem\[\[:>:\]\]') OR";}
					if ($q->param('url') eq "url") {$where_sql = $where_sql . "(A.url REGEXP '\[\[:<:\]\]$kwitem\[\[:>:\]\]') OR";}
					
					$where_sql = "(" . $where_sql;
					
							#$where_sql = $where_sql . " ((A.title REGEXP '\[\[:<:\]\]$kwitem\[\[:>:\]\]') or 
							#									  (A.description REGEXP '\[\[:<:\]\]$kwitem\[\[:>:\]\]') or 
							#									  (A.keywords REGEXP '\[\[:<:\]\]$kwitem\[\[:>:\]\]') or";
				
				}
				elsif ($SQLSearch_Method eq "REGEXPR")
				{
				$where_sql = $where_sql . " (A.title REGEXP '\[\[:<:\]\]$kwitem\[\[:>:\]\]') or 
													 (A.description REGEXP '\[\[:<:\]\]$kwitem\[\[:>:\]\]') or 
													 (A.keywords REGEXP '\[\[:<:\]\]$kwitem\[\[:>:\]\]') or";
				
				
				}
				elsif ($SQLSearch_Method eq "STANDARD_SQL")
				{
				$where_sql = $where_sql . " (A.title like '% $kwitem %') or (A.title like '% $kwitem%') or (A.title like '%$kwitem %') or (A.title like '$kwitem') or
													(A.description like '% $kwitem %') or (A.description like '% $kwitem%') or (A.description like '%$kwitem %') or 
													(A.keywords like '% $kwitem %') or (A.keywords like '% $kwitem%') or (A.keywords like '%$kwitem %') or";
				}
				else
				{
				
				if ($q->param('fct') eq "advanced") ### ADVANCED SEARCH / PHRASE & NORMAL ADVANCED
					{
					if ($q->param('title') eq "title") {$where_sql = $where_sql . "(A.title like '%$kwitem%') or";}
					if ($q->param('diz') eq "description") {$where_sql = $where_sql . "(A.description like '%$kwitem%') or";}
					if ($q->param('kw') eq "keywords") {$where_sql = $where_sql . "(A.keywords like '%$kwitem%') or";}
					if ($q->param('url') eq "url") {$where_sql = $where_sql . "(A.url like '%$kwitem%') or";}
					}
					else  ### NORMAL SEARCH
					{
						$where_sql = $where_sql . " (A.title like '%$kwitem%') or 
														    (A.description like '%$kwitem%') or 
														    (A.keywords like '%$kwitem%') or";
					}
				} 
			

								
				#####
			
				if (($knr2 > 0) and (length($specdir_sql) > 1)) ### IF WE NEED TO SEARCH EXTRA FIELDS/KEYS
					{
					$tmp_specdir_sql = $specdir_sql;
					$tmp_specdir_sql =~ s/KEYWORDS_HERE/$kwitem/gi;
					
				   
						if (($q->param('fct') eq "advanced") and ($q->param('mtype') eq "andkeywords")) ## ADVANCED AND MATCHING WITH EXTRA FIELDS
							{
							$tmp_specdir_sql = substr($tmp_specdir_sql,0,length($tmp_specdir_sql) -2);
							$tmp_specdir_sql = $tmp_specdir_sql . ") and";
							}
							
							$where_sql = $where_sql . $tmp_specdir_sql;
				   
					}
					elsif (($q->param('fct') eq "advanced") and ($q->param('mtype') eq "andkeywords")) ## ADVANCED AND MATCHING
					{
						$where_sql = substr($where_sql,0,length($where_sql) -2);
						$where_sql = $where_sql . ") and";
					}
					
				
			} ### foreach $kwitem (@allkeywords)
			
			
			#print "$where_sql"; #exit;
			
			

				if (($q->param('fct') eq "advanced") and ($q->param('mtype') eq "andkeywords")) ## IF ADVANCED AND MATCHING
					{
					$where_sql = substr($where_sql, 0, length($where_sql) - 3);
					}
					else ### OTHER MATCHING
					{
					$where_sql = substr($where_sql, 0, length($where_sql) - 2);
					}
						

		}
  else ### IF THERE IS NOT MORE THAN ONE KEYWORD
		{
		
		$keywords =~ s/'/\\'/g;

		if ($SQLSearch_Method eq "REGEXPR")
		{		
		$where_sql = "(A.title REGEXP '\[\[:<:\]\]$keywords\[\[:>:\]\]') or 
						  (A.description REGEXP '\[\[:<:\]\]$keywords\[\[:>:\]\]') or 
						  (A.keywords REGEXP '\[\[:<:\]\]$keywords\[\[:>:\]\]')";
		
		}
		elsif ($SQLSearch_Method eq "STANDARD_SQL")
		{
		$where_sql = "(A.title like '% $keywords% ') or (A.title like '%$keywords% ') or (A.title like '% $keywords%') or (A.title like '$keywords') or
						  (A.description like ' %$keywords% ') or (A.description like '%$keywords% ') or (A.description like ' %$keywords%') or
						  (A.keywords like ' %$keywords% ') or (A.keywords like '%$keywords% ') or (A.keywords like ' %$keywords%')";
		}
		elsif ($SQLSearch_Method eq "STANDARD_SQL_PW")
		{
		
		if ($q->param('fct') eq "advanced") 
			{
			if ($q->param('title') eq "title") {$where_sql = $where_sql . "(A.title like '%$keywords%') or";}
			if ($q->param('diz') eq "description") {$where_sql = $where_sql . "(A.description like '%$keywords%') or";}
			if ($q->param('kw') eq "keywords") {$where_sql = $where_sql . "(A.keywords like '%$keywords%') or";}
			if ($q->param('url') eq "url") {$where_sql = $where_sql . "(A.url like '%$keywords%') or";}
			$where_sql = substr($where_sql, 0, length($where_sql) - 2);
			}
			else
			{
			$where_sql = "(A.title like '%$keywords%') or 
							  (A.description like '%$keywords%') or 
							  (A.keywords like '%$keywords%')";
			}
		
		}
		elsif ($SQLSearch_Method eq "URL")
		{
		$keywords =~ s/link://gi;
		$where_sql = "(A.url like '%$keywords%')";
		}
		
		
		if (($knr2 > 0)  and (length($specdir_sql) > 1))
			{
			$tmp_specdir_sql = $specdir_sql;
			$tmp_specdir_sql =~ s/KEYWORDS_HERE/$keywords/gi;
			$where_sql = $where_sql . " or " . $tmp_specdir_sql;
		   $where_sql = substr($where_sql, 0, length($where_sql) - 2);
		   
		   		if (($q->param('fct') eq "advanced") and ($q->param('title') ne "title") and 
					($q->param('diz') ne "description") and ($q->param('kw') ne "keywords") and ($q->param('url') ne "url"))
		  			{
		   		$where_sql = substr($where_sql, 3, length($where_sql) - 2);
		   		}
			}						  
			
		}
	
	####
	if ($where_sql eq "") {&use_nomatch_template;}






### FINALYZE SELECT STATEMENT

if ($gsettings->{remove_duplicates} eq "Yes")
	{

		if ($gsettings->{remove_duplicates_filter} eq "Title")
			{
			$groupby_crit = "A.title";
			}
			else
			{
			$groupby_crit = "A.url";
			}

				  #0	   1     2     3     4     5    6      7     8     9      10     11     12     13     14     15     16     17
$sql = "SELECT B.cid,B.l1, B.l2, B.l3, B.l4, B.l5, B.l6, B.l7, B.l8, B.l9, B.l10, B.l11, B.l12, B.l13, B.l14, B.l15, B.l16, B.crosslinkid, A.*
			 FROM links AS A,
		       dirs AS B 
		       WHERE ($where_sql)
		       AND ((B.catlock != 'H') OR (B.catlock IS NULL))
		       AND (A.cid = B.cid) 
		       AND ((A.newsubm = '') OR (A.newsubm IS NULL))
		       $catsql
		       GROUP BY $groupby_crit
	       ";
	}
	else
	{

$sql = "SELECT B.cid, B.l1, B.l2, B.l3, B.l4, B.l5, B.l6, B.l7, B.l8, B.l9, B.l10, B.l11, B.l12, B.l13, B.l14, B.l15, B.l16, B.crosslinkid, A.* 
			 FROM links AS A,
		       dirs AS B 
		       WHERE ($where_sql)
		       AND ((B.catlock != 'H') OR (B.catlock IS NULL))
		       AND (A.cid = B.cid) 
		       AND ((A.newsubm = '') OR (A.newsubm IS NULL))
		       $catsql
	       ";
	 
	 }

#print "---> $sql <BR><BR><BR>";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

$rows = $sth->rows();
$search_templat =~ s/%%link_matches%%/$rows/g;
$search_templat =~ s/!!link_matches!!/$rows/g;


#################  PAY-PER-CLICK PLUGIN ##############################

if ($use_ppc_plugin == 1) {$kanoodle_settings = &ppc_settings; $kanoodle_enalbled = $kanoodle_settings->{kanoodle_enalbled}; $searchfeed_enalbled = $kanoodle_settings->{searchfeed_enalbled};}
if (($use_ppc_plugin == 1) and ($kanoodle_enalbled == 11)) { if ($q->param('st') eq ""){$kan_st = 0;} else {$kan_st = $q->param('st');} if ($rows > 0) {$which_search = 1;} else {$which_search = 10;} $all_kan_links = &do_kanoodle($keywords, $kan_st,$which_search); }
if (($use_ppc_plugin == 1) and ($searchfeed_enalbled == 11)) { if ($q->param('st') eq ""){$kan_st = 0;} else {$kan_st = $q->param('st');} if ($rows > 0) {$which_search = 1;} else {$which_search = 10;} $all_searchfeed_links = &do_searchfeed($keywords, $kan_st,$which_search); }

####################################################################


### PREPARE PAGES

$icnt = $rows;
$nr_searchres = $gsettings->{search_nrlinks_perpage};

$modp = ($icnt % $nr_searchres);
$pages = ($icnt - $modp) / $nr_searchres;
if ($modp != 0) {$pages++;}

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}

$main_nd = $nd;
$main_st = $st;


$ippc = 1;


###### GET LINKS PSEEK SEARCHING

	$rs_cnt = 0;
	while ( @row = $sth->fetchrow() )
		{
		$score = 1;

		### TITLE
		($titlescore, $t_phrase_scr, $t_wholeword_scr, $t_partialword_scr) = &assign_score($row[20], "TITLE");
		#$score = $score + ($titlescore * 40);
		$score = $score + $titlescore;
		
		### DESCRIPTION
		if ($row[21] ne "")
		{
		($dizscore, $d_phrase_scr, $d_wholeword_scr, $d_partialword_scr)  = &assign_score($row[21], "DIZ");
		#$score = $score + $dizscore;
		$score = $score + $dizscore;
		}
		
		### KEYWORDS
		if ($row[22] ne "")
		{
		($keywordscore, $k_phrase_scr, $k_wholeword_scr, $k_partialword_scr) = &assign_score($row[22], "KEYW");
		#$score = $score + ($keywordscore * 2);
		$score = $score + $keywordscore;
		}
		
		### URL
		#$urlscore = &assign_score($row[23]);
		#$score = $score + ($urlscore * 1);
		
		### EXTRA KEY MATCHES
		my ($extrafkdata);
		$exrafk_pos = 45;
		if ($specdir_sql ne "")
			{
			foreach $kitem (@akeys)
				{
				($keyname, $visible, $size, $searched, $description, $na, $imgk, $nmbr) = split (/\t/, $kitem);

				if (($searched eq "Yes") and ($imgk ne "Yes") and ($nmbr ne "Y"))
					{
					$extrafkdata = $extrafkdata . $row[$exrafk_pos] . " ";
					}
					
				$exrafk_pos++;
				}
					
					if ($extrafkdata ne "")
					{
					($extrk_score, $e_phrase_scr, $e_wholeword_scr, $e_partialword_scr) = &assign_score($extrafkdata, "EXTRAF");
					$score = $score + $extrk_score;
					}
			
			}


		### MULTIPLE WORD MATCHES (AND MATCHES THROUGHOUT LINK)
		$multimatch = 0; $mwordm = 0;
		if ($kwc > 1)
		{
		foreach $kwitem (@escaped_keywords_more)
			{
			
				$multimatch = 0;
					if ($row[20] =~ /\b$kwitem\b/i){$multimatch++;}
					if ($row[21] =~ /\b$kwitem\b/i){$multimatch++;}
					if ($row[22] =~ /\b$kwitem\b/i){$multimatch++;}
					if ($extrafkdata =~ /\b$kwitem\b/i){$multimatch++;}
				
				if ($multimatch > 0) { $mwordm++; }
				}
				if ($mwordm >= 2) ### IF AND MATCHES
					{
					$score = $score + ($and_match_score_adding * $mwordm);
					$multimatch = ($and_match_score_adding * $mwordm);
					}
				}


		if (($gsettings->{premium_first_search_results} eq "Y") and ($row[31] > 0))
			{
		   $score = $score + "99999999999";
			}




		if ($high_number < $score) { $high_number = $score; }
		
		#print "==> $row[19] == $score <BR><BR>";
		
		$writecrit = "";
		for (my $ms3 = 0; $ms3 < (46 + $knr); $ms3++) 
			{
			if ($ms3 == 0)
				{
				$writecrit = "0" . (99999 - $score) . "\t";
				}
				elsif ($ms3 == (45 + $knr))
				{
				if ($debug_scores eq "Y")
					{
					$writecrit = $writecrit . 
					"$score-$t_phrase_scr-$t_wholeword_scr-$t_partialword_scr" . 
					"-$d_phrase_scr-$d_wholeword_scr-$d_partialword_scr" . 
					"-$k_phrase_scr-$k_wholeword_scr-$k_partialword_scr" . 
					"-$e_phrase_scr-$e_wholeword_scr-$e_partialword_scr" . 
					"-$multimatch" . 
					"\t";
					}
					else
					{
					$writecrit = $writecrit . "$score\t";
					}
				}
				else
				{
				$writecrit = $writecrit . "$row[$ms3]\t";
				}
			}


		$results_array[$rs_cnt] = $writecrit;
		$rs_cnt++;
		}

$sth->finish;
$dbh->disconnect;



##########

@results_array = sort(@results_array);


	foreach $searched_item (@results_array)
		{
		
		#print "$row[0]<Br>";
		
		if (($ippc > $st) and ($ippc <= $nd))
		    {
		    @row = split (/\t/, $searched_item);
			 &display_results;
			 }
		$ippc++;
		}


#########

if ($rows < 1)
	{
	if ($gsettings->{nomatch_template} eq "default_tmpl")
		{
		$search_templat =~ s/%%searchresults%%/$gsettings->{no_match_text}/g;
		
#################  PAY-PER-CLICK PLUGIN ##############################

		if (($use_ppc_plugin == 1) and ($kanoodle_enalbled == 11)) { $search_templat =~ s/%%kanoodle_search%%/$all_kan_links/g; }
		if (($use_ppc_plugin == 1) and ($searchfeed_enalbled == 11)) { $search_templat =~ s/%%searchfeed_search%%/$all_searchfeed_links/g; }
		
####################################################################

		}
		else
		{
		&use_nomatch_template; exit;
		}
	}
	else
	{
	$search_templat =~ s/%%searchresults%%/$all_links/g;
	
#################  PAY-PER-CLICK PLUGIN ##############################
	
	if (($use_ppc_plugin == 1) and ($kanoodle_enalbled == 11)) { $search_templat =~ s/%%kanoodle_search%%/$all_kan_links/g; }
	if (($use_ppc_plugin == 1) and ($searchfeed_enalbled == 11)) { $search_templat =~ s/%%searchfeed_search%%/$all_searchfeed_links/g; }

####################################################################

	}



#### PAGE NAVIGATION

$original_keywords =~ s/ /+/g;

	for ($ms = 0; $ms < $pages; $ms++) 
		{
		$pg = $ms + 1;
		if ($nd == ($pg * $nr_searchres)){ $cnposition = $pg; }
		}
	if ($cnposition < $pages_next) { $pages_next = $pages_next + $pages_next - ($cnposition - 1); }

	$hiddenstr = "";
	$pgstring = "";
	
	if ($main_nd eq "") {$main_nd = $nr_searchres;}
	
	for ($ms = 0; $ms < $pages; $ms++)
		{
		$pg = $ms + 1;
		
			if ($main_nd == ($pg * $nr_searchres))
				{
				$pgstring = $pgstring . " [$pg] ";
				$currentpage = $pg;
				}
			  	elsif (($pg >= ($cnposition - $pages_prev)) and ($pg <= ($cnposition + $pages_next)))
				{
				$st = ($pg * $nr_searchres) - $nr_searchres;
				$nd = ($pg * $nr_searchres);
				
				if ($q->param('fct') eq "advanced") 
					{
					$pgstring = $pgstring . "<a href=\"$script_url/search.cgi?st=$st&nd=$nd&keywords=$passon_keywords&cat_search=$cat_search_orig&title=" . 
					$q->param('title') . "&diz=" . $q->param('diz') . "&kw=" . $q->param('kw') . "&url=" . $q->param('url') . "&mtype=" . $q->param('mtype') . "&fct=advanced" . $passon_crit . 
					"\">$pg</a> ";
					}
					else
					{
					$pgstring = $pgstring . "<a href=\"$script_url/search.cgi?st=$st&nd=$nd&keywords=$passon_keywords&cat_search=$cat_search_orig\">$pg</a> ";
					}
			   }
      } 

			####  PAGES NAVIGATION
			if (($cnposition - $pages_prev) > 1)
				{
				$prev_ppos = $cnposition - $pages_prev;
				$staticpos = $prev_ppos - 1;
				$prev_ppos = $prev_ppos - 2;
				$pvst = $prev_ppos * $nr_searchres;
				$pvnd = ($prev_ppos * $nr_searchres) + $nr_searchres;

					if ($q->param('fct') eq "advanced") 
						{
						$pgstring = "<a href=\"$script_url/search.cgi?st=$pvst&nd=$pvnd&keywords=$passon_keywords&cat_search=$cat_search_orig&title=" . 
						$q->param('title') . "&diz=" . $q->param('diz') . "&kw=" . $q->param('kw') . "&url=" . $q->param('url') . "&mtype=" . $q->param('mtype') . "&fct=advanced" .  $passon_crit . 
						"\"><<</a> " . $pgstring;
						}
						else
						{
						$pgstring = "<a href=\"$script_url/search.cgi?st=$pvst&nd=$pvnd&keywords=$passon_keywords&cat_search=$cat_search_orig\"><<</a> " . $pgstring;
						}
					
				}

			####  PAGES NAVIGATION
			if (($cnposition + $pages_next) < $pages)
				{
				$next_ppos = $cnposition + $pages_next;
				$staticpos = $next_ppos + 1;
				$pvst = $next_ppos * $nr_searchres;
				$pvnd = ($next_ppos * $nr_searchres) + $nr_searchres;

					if ($q->param('fct') eq "advanced") 
						{
						$pgstring = $pgstring . "<a href=\"$script_url/search.cgi?st=$pvst&nd=$pvnd&keywords=$passon_keywords&cat_search=$cat_search_orig&title=" . 
						$q->param('title') . "&diz=" . $q->param('diz') . "&kw=" . $q->param('kw') . "&url=" . $q->param('url') . "&mtype=" . $q->param('mtype') . "&fct=advanced" .  $passon_crit . 
						"\">>></a> ";
						}
						else
						{
						$pgstring = $pgstring . "<a href=\"$script_url/search.cgi?st=$pvst&nd=$pvnd&keywords=$passon_keywords&cat_search=$cat_search_orig\">>></a> ";
						}
				
				}


if ($pgstring eq "0") { $pgstring = ""; }
if ($pgstring eq " [1] ") { $pgstring = ""; }

if ($pgstring ne "") {$pgstring =  $gsettings->{pages} . $pgstring; }

$search_templat =~ s/%%pages%%/$pgstring/gi;
$search_templat =~ s/!!page!!/$currentpage/gi;

$ppc_keywords = &get_search_ready($q->param('keywords')); $ppc_keywords =~ s/ /+/g;
$search_templat =~ s/!!ppc_keywords!!/$ppc_keywords/gi;



### PREV NEXT PAGES

$st = $q->param('st');
$nd = $q->param('nd');
if ($st eq ""){$st = 0;}
if ($nd eq ""){$nd = $nr_searchres;}


$spls = $modp;
if ($spls == 0){$spls++;}

	if ($nd <= ($icnt - $spls))
	{
		$st1 = $st + $nr_searchres;
		$nd1 = $nd + $nr_searchres;
		
		if ($q->param('fct') eq "advanced") 
			{
			$nextt = "<a href=\"$script_url/search.cgi?st=$st1&nd=$nd1&keywords=$passon_keywords&cat_search=$cat_search_orig&title=" . 
			$q->param('title') . "&diz=" . $q->param('diz') . "&kw=" . $q->param('kw') . "&url=" . $q->param('url') . "&mtype=" . $q->param('mtype') . "&fct=advanced" .  $passon_crit . 
			"\">$gsettings->{nextpage}</a> ";
			}
			else
			{
			$nextt = "<a href=\"$script_url/search.cgi?st=$st1&nd=$nd1&keywords=$passon_keywords&cat_search=$cat_search_orig\">$gsettings->{nextpage}</a> ";
			}
	}

 if ($st > 0)
	 	{
		$st1 = $st - $nr_searchres;
		$nd1 = $nd - $nr_searchres;
		
				if ($q->param('fct') eq "advanced") 
				{
				$prev = "<a href=\"$script_url/search.cgi?st=$st1&nd=$nd1&keywords=$passon_keywords&cat_search=$cat_search_orig&title=" . 
				$q->param('title') . "&diz=" . $q->param('diz') . "&kw=" . $q->param('kw') . "&url=" . $q->param('url') . "&mtype=" . $q->param('mtype') . "&fct=advanced" .  $passon_crit . 
				"\">$gsettings->{prevpage}</a> ";
				}
				else
				{
				$prev = "<a href=\"$script_url/search.cgi?st=$st1&nd=$nd1&keywords=$passon_keywords&cat_search=$cat_search_orig\">$gsettings->{prevpage}</a> ";
				}
		
		}

if (($prev ne "") and ($nextt ne ""))
	{
	$spcer = " | ";
	}
	else
	{
	$spcer = " ";
	}
	  
	$prevnext = $prev . "$spcer" . $nextt;

	if (length($prevnext) > 5){$myspacer = " | ";}

	$search_templat =~ s/%%prevnext%%/$prevnext/g;

	$search_templat = &ts_insert_template_includes($search_templat);

	$search_templat = &fill_vars($search_templat); 




#print "Script Benchmark: ".timestr(timediff($time1,$time0));
#my $time0 = new Benchmark;
#my $time1 = new Benchmark;




###################################################################
### IF WE ARE GOING TO FETCH PPC RESULTS FROM POWERSEEK PPC PLUGIN
###################################################################
$ppc_ps_loc = $config_cgi;
$ppc_ps_loc =~ s/config\.cgi//gi;
$ppc_ps_loc = $ppc_ps_loc . "ppc_login.cgi";
if ((-e "$ppc_ps_loc") > 0)
	{
	$ppc_results = ppc_ps::get_ppc_results($okeywords, $currentpage);
	$search_templat =~ s/!!ppc_results!!/$ppc_results/gi;
	}
###################################################################

$keywords9 = $keywords;
$keywords9 =~ s/</&lt;/g; $message =~ s/>/&gt;/g; 

$search_templat =~ s/%%keywords%%/$keywords9/g;
$search_templat =~ s/!!keywords!!/$keywords9/g;
$search_templat =~ s/!!advanced!!/$script_url\/searchadv\.cgi/g;

$search_templat =~ s/%%kanoodle_search%%//g;
$search_templat =~ s/%%searchfeed_search%%//g;

print $search_templat;



#####################################


sub display_results
{

$nowtime = time();

	if (($row[39] == 0) and ($row[31] > 0))
	{ $row[39] = 99999999999999; }
		
	if (($row[31] > 0) and ($row[39] > $nowtime))
		{
		$search_links_tmp = $search_links_prem;
		}
		else
		{
		$search_links_tmp = $search_links;
		}
    
    
			
	 		### %%title_with_link%%
	 		if ($gsettings->{search_res_newwin} eq "Yes")
	 			{
	 			$new_win_crit = " target=\"_blank\"";
	 			}
			
			
			if ($gsettings->{hideurls} eq "No")
				{
				$title_with_link = "<a href=\"$row[23]\" $new_win_crit>$row[20]</a>";
				}
				else
				{
				$title_with_link = "<a href=\"$script_url/go.cgi?id=$row[18]\" $new_win_crit>$row[20]</a>";
				}
			
			if (($row[23] eq "http://") or ($row[23] eq ""))
				{
				$title_with_link = "$row[20]";
				}
			
			
			$search_links_tmp =~ s/!!nr!!/$ippc/g;
			$search_links_tmp =~ s/%%title_with_link%%/$title_with_link/g;
			$search_links_tmp =~ s/!!title_with_link!!/$title_with_link/g;

			$search_links_tmp =~ s/!!cid!!/$row[0]/g;
			$search_links_tmp =~ s/!!id!!/$row[18]/g;
			
			### !!title_without_link!!
			$search_links_tmp =~ s/!!title_without_link!!/$row[20]/g;
			
			### %%description%%
			
			$search_links_tmp =~ s/%%description%%/$row[21]/g;
			$search_links_tmp =~ s/!!description!!/$row[21]/g;

			$search_links_tmp =~ s/!!listing_keywords!!/$row[22]/g;
			
			### !!url!! or !!itemurl!!
			$search_links_tmp =~ s/!!url!!/$row[23]/g;
			$search_links_tmp =~ s/!!itemurl!!/$row[23]/g;
			$search_links_tmp =~ s/!!hidden_url!!/$script_url\/go\.cgi?id=$row[18]/g;

			$domaincrit = $row[23];
			$domaincrit =~ s/http:\/\///gi;
			if ($domaincrit =~ /\//){ @domainrtmp = split(/\//, $domaincrit); $domainr = $domainrtmp[0];} else {$domainr = $domaincrit; }
			$search_links_tmp =~ s/!!domain!!/$domainr/gi;
			
			### !!name!!
			$search_links_tmp =~ s/!!name!!/$row[26]/g;

			### !!email!!
			$search_links_tmp =~ s/!!email!!/$row[27]/g;
			
			### !!gethtml!!
			$search_links_tmp =~ s/!!gethtml!!/$script_url\/gethtml\.cgi?id=$row[18]-$row[19]/g;
			
			### %%date%%
			$reald = $row[35];
			$row[35] = &decode_date($row[35]);
			$search_links_tmp =~ s/%%date%%/$row[35]/g;
			$search_links_tmp =~ s/!!date!!/$row[35]/g;
			
			### %%votes%% 
			if ($row[29] eq "") { $row[29] = 0; }
			$search_links_tmp =~ s/%%votes%%/$row[29]/g;
			$search_links_tmp =~ s/!!votes!!/$row[29]/g;
			
			my $nrc = "";
			if ($row[41] > 0) { $nrc = "($row[41])"; }
			
			$reviews = "<a href=\"$script_url/reviews.cgi?id=$row[18]&cid=$row[19]\">$gsettings->{comments}</a> $nrc";
			$search_links_tmp =~ s/%%reviews%%/$reviews/g;

			$search_links_tmp =~ s/!!rno!!/$nrc/gi;
			$search_links_tmp =~ s/!!review_link_url!!/$script_url\/reviews\.cgi?id=$row[18]&cid=$row[19]/gi;
			
			### %%modify%%
			$modifyl = $gsettings->{modify_text};
			$modifyl = "<a href=\"$script_url/modify.cgi?id=$row[18]&cid=$row[19]\">$modifyl</a>";
			$search_links_tmp =~ s/%%modify%%/$modifyl/gi;
			$search_links_tmp =~ s/!!modify_link!!/$script_url\/modify\.cgi?id=$row[18]&cid=$row[19]/gi;


			### !!add_to_favorites!!
			$search_links_tmp =~ s/!!add_to_favorites!!/$script_url\/favad\.cgi?id=$row[18]/gi;
			

			### %%report%%
			$rptdl = $gsettings->{report_dead_link};
			$rptdl = "<a href=\"$script_url/rprtb.cgi?id=$row[18]&cid=$row[19]\">$rptdl</a>";
			$search_links_tmp =~ s/%%report%%/$rptdl/gi;
			$search_links_tmp =~ s/!!report_dead_link!!/$script_url\/rprtb\.cgi?id=$row[18]&cid=$row[19]/gi;


			### %%rateit%% %%rating%%
			$rateit = "<a href=\"$script_url/rateit.cgi?id=$row[18]&cid=$row[19]\">$gsettings->{rateit}</a>";
			$search_links_tmp =~ s/%%rateit%%/$rateit/g;
			$search_links_tmp =~ s/!!rate_link_url!!/$script_url\/rateit\.cgi?id=$row[18]&cid=$row[19]/g;
			
			if ($row[28] eq "") { $row[28] = 0; }
			$search_links_tmp =~ s/%%rating%%/$row[28]/g;
			$search_links_tmp =~ s/!!rating!!/$row[28]/g;
			
			$rating_image = "";
			$rating_image = &get_rating_images($row[28]);
			$search_links_tmp =~ s/%%rating_image%%/$rating_image/gi;
			$search_links_tmp =~ s/!!rating_image!!/$rating_image/gi;

			### %%hits%%
			if ($row[30] eq "") { $row[30] = 0; }
			$search_links_tmp =~ s/%%hits%%/$row[30]/g;
			$search_links_tmp =~ s/!!hits!!/$row[30]/g;
			
		### NEW
		if	($reald ne "")
			{
			$time1 = 86400 * $gsettings->{days1};
			if ($reald >= ($today_time - $time1)){ $crit = "<img src=\"!build_url!/new1.gif\">"; $search_links_tmp =~ s/!!new!!/$crit/g; }

			$time2 = 86400 * $gsettings->{days2};
			if ($reald >= ($today_time - $time2)){ $crit = "<img src=\"!build_url!/new2.gif\">"; $search_links_tmp =~ s/!!new!!/$crit/g; }

			$time3 = 86400 * $gsettings->{days3};
			if ($reald >= ($today_time - $time3)){ $crit = "<img src=\"!build_url!/new3.gif\">"; $search_links_tmp =~ s/!!new!!/$crit/g; }
			}
			$search_links_tmp =~ s/!!new!!//gi;


		### POP
			if ($row[30] > $gsettings->{pop_links_amount})
				{
				$crit = "<img src=\"!build_url!/pop.gif\">";
				$search_links_tmp =~ s/!!pop!!/$crit/gi;
				}
				else
				{
				$search_links_tmp =~ s/!!pop!!//gi;
				}
			
			
			### %%category%%
			### GET ENCODED CAT

			$cats = ""; $rdcat = ""; $ecat = ""; $lv = 0;
			for ($ms = 1; $ms < 17; $ms++) 
				{
				if ($row[$ms] ne "")
					{
					$cats = $cats . $row[$ms] . "/";
					$rdcat = $rdcat . &encode_dir($row[$ms]) . "/";
					$ecat = $ecat . &encode_dir($row[$ms]) . "-";
					$lastcat = $row[$ms];
					$lv++;
					}
				}
			chop($ecat);

			
			$cats = substr($cats, 0, (length($cats) - 1));
			$cats =~ s/\// \/ /gi;
			if ($gsettings->{dyn_stat} eq "Dynamic")
				{
				$from_category = "<a href=\"$script_url/dirs.cgi?lv=$lv&ct=$ecat\">$cats</a>";
				$lastcat = "<a href=\"$script_url/dirs.cgi?lv=$lv&ct=$ecat\">$lastcat</a>";
				}
				else
				{
				$from_category = "<a href=\"$web_url/$rdcat\">$cats</a>";
				$lastcat = "<a href=\"$web_url/$rdcat\">$lastcat</a>";
				
				}
				
			$search_links_tmp =~ s/%%category%%/$from_category/g;
			$search_links_tmp =~ s/!!category!!/$from_category/g;

			$search_links_tmp =~ s/!!short_category!!/$lastcat/g;
			

			### GET RELEVANCE %%rgraphic%% %%relevance%%
			#print "==> " . $row[45] . "- $knr - $high_number<BR>";
			
			if (($row[45 + $knr] != 0) and ($high_number > 0))
				{
				$perc = $row[45 + $knr] / $high_number * 100;
				$perc = sprintf("%5.2f",$perc);
				}
				else
				{
				$perc = "1.00";
				}
				
			
			#$perc = $perc . " : -> $row[45]";
			
			if (int($perc) == 100) { $perc = "99.99"; }
			
			$search_links_tmp =~ s/%%relevance%%/$perc%/g;
			$search_links_tmp =~ s/!!relevance!!/$perc%/g;
				
				####
			
			$rgraphic = "";
			
			if ($perc < 100) { $rgraphic = "<img src=\"$web_url/100.gif\">"; }
			if ($perc < 91) { $rgraphic = "<img src=\"$web_url/90.gif\">"; }
			if ($perc < 81) { $rgraphic = "<img src=\"$web_url/80.gif\">"; }
			if ($perc < 71) { $rgraphic = "<img src=\"$web_url/70.gif\">"; }
			if ($perc < 61) { $rgraphic = "<img src=\"$web_url/60.gif\">"; }
			if ($perc < 51) { $rgraphic = "<img src=\"$web_url/50.gif\">"; }
			if ($perc < 41) { $rgraphic = "<img src=\"$web_url/40.gif\">"; }
			if ($perc < 31) { $rgraphic = "<img src=\"$web_url/30.gif\">"; }
			if ($perc < 21) { $rgraphic = "<img src=\"$web_url/20.gif\">"; }
			if ($perc < 11) { $rgraphic = "<img src=\"$web_url/10.gif\">"; }
			
			$search_links_tmp =~ s/%%rgraphic%%/$rgraphic/g;
			$search_links_tmp =~ s/!!rgraphic!!/$rgraphic/g;
		
			### !!more_info_url!!
			if ($gsettings->{dyn_stat} eq "Static")
				{
				
				if ($gsettings->{more_info_naming} eq "linktitles")
					{
					$fext = "$web_url/$rdcat" . &get_more_info_file_name($row[20], $row[18]);
					}
					else
					{
					$fext = "$web_url/$rdcat" . $row[18];
					}
					
					$fext = $fext . $gsettings->{gen_file_ext};
				
				$search_links_tmp =~ s/!!more_info_url!!/$fext/g;
				}
				else
				{
				$search_links_tmp =~ s/!!more_info_url!!/$script_url\/linfo\.cgi?id=$row[18]/g;
				}


			#### EXTRA FIELDS KEYS
			$rowcntr = 45;
			foreach $keyitem(@akeys)
				{
				($keyname, $visible, $size, $searched, $description, $na, $imgk, $nmbr) = split (/\t/, $keyitem);


					if ($nmbr eq "Upload")
					{
					 if ($row[$rowcntr] eq "") 
						 {
						 $search_links_tmp =~ s/!!$keyname!!/$na/g;
						 }
						else
						 {
							$apreapp = ""; $aapend = "";
							foreach $upload_item (@upl_items)
								{
								($fieldname_t, $filetypes_t, $preappend_t, $append_t, $uploadsize_t) = split (/:o:-:o:/, $upload_item);
								if ($keyname eq $fieldname_t) { $apreapp = $preappend_t; $aapend = $append_t; }
								}
									
							$upcrit = $apreapp . "$web_url/imagefiles/$row[18]/$keyname" . "." . $row[$rowcntr] . $aapend;
							$search_links_tmp =~ s/!!$keyname!!/$upcrit/g;
						 } 
					  }
					elsif ($imgk eq "Yes")
						{
						if ($row[$rowcntr] ne ""){$imgcrit = "<img src=\"$row[$rowcntr]\" border=\"0\">";} else { $imgcrit = $na; }
						$search_links_tmp =~ s/%%$keyname%%/$imgcrit/gi;
						$search_links_tmp =~ s/!!$keyname!!/$imgcrit/gi;
						}
						else
						{
						if ($row[$rowcntr] eq "") { $row[$rowcntr] = $na; }
						$search_links_tmp =~ s/%%$keyname%%/$row[$rowcntr]/gi;
						$search_links_tmp =~ s/!!$keyname!!/$row[$rowcntr]/gi;
						}
						$rowcntr++;
		
						
				}
			
			##### INSERT IMAGES
			
			$search_links_tmp = &insert_images($search_links_tmp, "$script_url/go.cgi?id=$row[18]");
			

			### INSERT UPLOAD IMAGE IF ANY
			if ($search_links_tmp =~ /!!link_image!!/i)
			{
			$img_fname = "$web_dir/imagefiles/" . $row[18] . "." . $row[24];
	
			$image_width = $gsettings->{image_width};
			$image_height = $gsettings->{image_height};
	
			if ($image_width > 0) { $imgw = qq[ width="$image_width" ]; }
			if ($image_height > 0) { $imgh = qq[ height="$image_height" ]; }
	
						
				if (-e "$img_fname")
					{
					$the_image_url = "$web_url/imagefiles/$row[18]" . "." . $row[24];
					$the_link_image = qq[<img src="$the_image_url" border="0" $imgw $imgh>];
					$search_links_tmp =~ s/!!link_image!!/$the_link_image/gi;
					}
					else
					{
					if ($gsettings->{default_image} =~ /http:/)
						{
						$the_image_url = $gsettings->{default_image};
						$the_link_image = qq[<img src="$the_image_url" border="0" $imgw $imgh>];
						$search_links_tmp =~ s/!!link_image!!/$the_link_image/gi;
						}
						else
						{
						$search_links_tmp =~ s/!!link_image!!//gi;
						}
	
					}
			}					
			elsif ($search_links_tmp =~ /!!link_file!!/i)
			{
				if ($row[24] ne "") {$the_image_url = "$web_url/imagefiles/$row[18]" . "." . $row[24];}
				elsif ($gsettings->{default_image} =~ /http:/) { $the_image_url = 	$gsettings->{default_image};}
				
			$search_links_tmp =~ s/!!link_file!!/$the_image_url/gi;
			}
			
			
		$imgnm = "";
		if ($row[24] ne ""){$imgnm = $row[18] . "." . $row[24];}
		$search_links_tmp =~ s/!!image_name!!/$imgnm/gi;

			
			###### 
			
		$all_links = $all_links . $search_links_tmp;



		
		
		if ($debug_scores eq "Y")
			{
			($total_score, 
			$t_phrase_scr1,  $t_wholeword_scr1,  $t_partialword_scr1,
			$d_phrase_scr1, $d_wholeword_scr1, $d_partialword_scr1,
			$k_phrase_scr1, $k_wholeword_scr1, $k_partialword_scr1, 
			$e_phrase_scr1, $e_wholeword_scr1, $e_partialword_scr1, 
			$mlmatch) = split (/-/, $row[45+$knr]);
			
			#$all_links = $all_links . "<BR>";
			$all_links = $all_links . "Title: Phrase=$t_phrase_scr1, Whole=$t_wholeword_scr1, Partial=$t_partialword_scr1<BR>";
			$all_links = $all_links . "Description: Phrase=$d_phrase_scr1, Whole=$d_wholeword_scr1, Partial=$d_partialword_scr1<BR>";
			$all_links = $all_links . "Keywords: Phrase=$k_phrase_scr1, Whole=$k_wholeword_scr1, Partial=$k_partialword_scr1<BR>";
			$all_links = $all_links . "Extra Fields: Phrase=$e_phrase_scr1, Whole=$e_wholeword_scr1, Partial=$e_partialword_scr1<BR>";
			$all_links = $all_links . "AND Matching: $mlmatch<BR>";
			$all_links = $all_links . "<b>TOTAL</b>: $total_score<BR>";
			#$all_links = $all_links . "<b>TOTAL</b>: $row[45+$knr]<BR>";
			}
		

}





###########################

sub assign_score
{
my ($scrit, $whatmatch) = @_;

my ($search_kw, $linkscore, $count, $sckw, $wholesc, 
	 $phrase_return_score, $wholeword_return_score, $partialword_return_score, $partscor);


if ($whatmatch eq "TITLE")
	{
	$phrase_match_score = $t_phrase_match_score;
	$whole_word_match_score = $t_whole_word_match_score;
	$partial_match_score = $t_partial_match_score;
	}
	elsif ($whatmatch eq "DIZ")
	{
	$phrase_match_score = $d_phrase_match_score;
	$whole_word_match_score = $d_whole_word_match_score;
	$partial_match_score = $d_partial_match_score;
	}
	elsif ($whatmatch eq "KEYW")
	{
	$phrase_match_score = $k_phrase_match_score;
	$whole_word_match_score = $k_whole_word_match_score;
	$partial_match_score = $k_partial_match_score;
	}
	elsif  ($whatmatch eq "KEYW")
	{
	$phrase_match_score = $e_phrase_match_score;
	$whole_word_match_score = $e_whole_word_match_score;
	$partial_match_score = $e_partial_match_score;
	}



### GET KEYWORDS IN A STATE WHERE WE CAN MATCH THEM
#$search_kw = &get_search_ready($keywords);




### PHRASES MATCHING
if ($kwc > 1)
	{
	if ($scrit =~ /\b$escaped_keywords\b/i)
		{
		$count = 0;
		$count = () = $scrit =~ m/\b$escaped_keywords\b/ig; ### COUNT NUMBER OF MATCHES
		#$linkscore = $linkscore + (500 * $count);
		$linkscore = $linkscore + ($phrase_match_score * $count);
		$phrase_return_score = ($phrase_match_score * $count);
		$scrit =~ s/\b$escaped_keywords\b//gi;
		}
	}




### WHOLE WORDS

if ($kwc > 1)
	{

	foreach $sckw (@escaped_keywords_more)
		{
		
		if ($scrit =~ /\b$sckw\b/i)
			{
			$count = 0;
			$count = () = $scrit =~ m/\b$sckw\b/ig;
			$linkscore = $linkscore + ($whole_word_match_score * $count);
			$wholesc = $wholesc + ($whole_word_match_score * $count);
			$scrit =~ s/\b$sckw\b//gi;
			}
		}
		
		$wholeword_return_score = $wholesc;
		
	}
	else
	{
	
	if ($scrit =~ /\b$escaped_keywords\b/i)
		{
		$count = 0;
		$count = () = $scrit =~ m/\b$escaped_keywords\b/ig;
		$linkscore = $linkscore + ($whole_word_match_score * $count);
		$wholesc = $wholesc + ($whole_word_match_score * $count);
		$wholeword_return_score = $wholesc;
		$scrit =~ s/\b$escaped_keywords\b//gi;
		}
	}





### PARTIAL WORDS (WORDS RESEMBLING THE KEYWORDS)

	if ($kwc > 1)
		{
		foreach $sckw (@escaped_keywords_more)
			{
			
			if ($scrit =~ /$sckw/i)
				{
				#$linkscore = $linkscore + 1;
				$count = 0;
				$count = () = $scrit =~ m/$sckw/ig;
				$linkscore = $linkscore + ($partial_match_score * $count);
				$partscor = $partscor + ($partial_match_score * $count);
				$scrit =~ s/$sckw//gi;
				}
			}
		
		$partialword_return_score = $partscor;
		
		}
		else
		{
		if ($scrit =~ /$escaped_keywords/i)
			{
			#$linkscore = $linkscore + 1;
			$count = 0;
			$count = () = $scrit =~ m/$escaped_keywords/ig;
			
			$linkscore = $linkscore + ($partial_match_score * $count);
			$partscor = $partscor + ($partial_match_score * $count);
			
			$partialword_return_score = $partscor;
			
			$scrit =~ s/$escaped_keywords//gi;
			}
		}

#print "=S> $linkscore <BR>";

return ($linkscore, $phrase_return_score, $wholeword_return_score, $partialword_return_score);
}



sub get_search_ready
{
my ($search_line, $reline) = @_;

$reline = $search_line;

#$reline =~ s/\+/c%2B/g;
$reline =~ s/\[//g;
$reline =~ s/\]//g;
#$reline =~ s/\)//g;
#$reline =~ s/\(//g;
#$reline =~ s/\*//g;
#$reline =~ s/\^//g;
#$reline =~ s/\.//g;
#$reline =~ s/\$//g;
#$reline =~ s/\?//g;
#$reline =~ s/\\//g;
#$reline =~ s/\~//g;
#$reline =~ s/<//g;
#$reline =~ s/>//g;
#$reline =~ s/;//g;

return ($reline);
}







sub use_nomatch_template
{
my ($nomatch, $addurl, $addurl);

$nomatch = &get_file_contents("$data_dir/nomatch.html");

$nomatch =~ s/%%keywords%%/$original_keywords/g;

#################  PAY-PER-CLICK PLUGIN ##############################

if (($use_ppc_plugin == 1) and ($kanoodle_enalbled == 11)) {$nomatch =~ s/%%kanoodle_search%%/$all_kan_links/g; }
if (($use_ppc_plugin == 1) and ($searchfeed_enalbled == 11)) {$nomatch =~ s/%%searchfeed_search%%/$all_searchfeed_links/g; }

###################################################################
### IF WE ARE GOING TO FETCH PPC RESULTS FROM POWERSEEK PPC PLUGIN
###################################################################
$ppc_ps_loc = $config_cgi;
$ppc_ps_loc =~ s/config\.cgi//gi;
$ppc_ps_loc = $ppc_ps_loc . "ppc_login.cgi";
if ((-e "$ppc_ps_loc") > 0)
	{
	$ppc_results = ppc_ps::get_ppc_results($okeywords, 0, "NOMATCH");
	$nomatch =~ s/!!ppc_results!!/$ppc_results/gi;
	}
###################################################################


$nomatch =~ s/!!scripts_url!!/$script_url/g;
$nomatch =~ s/!!tseeksearch!!/$script_url\/search.cgi/g;
$nomatch =~ s/!build_url!/$web_url/g;
$nomatch =~ s/!!build_url!!/$web_url/g;


$nomatch = &ts_insert_template_includes($nomatch);
$nomatch = &fill_vars($nomatch); 

$addurl = "<a href=\"$script_url/addurl.cgi\">$gsettings->{add_url_link}</a>";
$nomatch =~ s/%%addurl%%/$addurl/g;
$nomatch =~ s/!!advanced!!/$script_url\/searchadv\.cgi/g;
$nomatch =~ s/!!rgs_login!!/$script_url\/rgs_login\.cgi/g;
$nomatch =~ s/!!register!!/$script_url\/rgs_register\.cgi/g;

$nomatch =~ s/!!favorites_link!!/$script_url\/fav\.cgi/g;


$nomatch =~ s/%%kanoodle_search%%//g;
$nomatch =~ s/%%searchfeed_search%%//g;

print $nomatch;
exit;
}



sub get_file_contents
{

my ($filename) = @_;
my ($filesize, $filesize, $thefile);

if ((-e "$filename") > 0) 
	{
$filesize = (-s "$filename");
open (TFILECNTS, "$filename") || die "$filename";
	read(TFILECNTS,$thefile,$filesize);
close (TFILECNTS);
	}

return ($thefile);

}




sub decode_dir
{

my ($coded_string) = @_;
my ($ms, $oneletter, $decoded_string, $plusval, $dechar, $dechar, $fdchar);

$coded_string =~ s/_/ /g;

$plusval = 0;

 for ($ms = 0; $ms < length($coded_string); $ms++) 
	{
	$oneletter = substr($coded_string, $ms, 1);

	if ($plusval != 0)
		{
		$plusval++;
		if ($plusval == 4) {$plusval = 0;}
		}
	elsif ($oneletter eq ",")
		{
		$dechar = substr($coded_string, ($ms+1), 3);
		$dechar = int($dechar);
		$dechar = chr($dechar);
		
		$dechar =~ s/<//g;
		
		$decoded_string = $decoded_string . $dechar;
		$plusval++;
		}
	else 
		{
		$decoded_string = $decoded_string . $oneletter;
		}

	}

return($decoded_string);
}




sub ts_insert_template_includes
{

my ($tmpl_page) = @_;
my (@files, $ifilen, $incl, $theincl);

opendir(DIR,"$data_dir");
@files = readdir(DIR);
closedir(DIR);

if ($tmpl_page =~ /%%incl_/)
	{
	foreach $ifilen (@files)
		{
		if (substr($ifilen, 0, 5) eq "incl_")
			{
			$incl = $ifilen;
			$incl =~ s/\.html//g;
			$incl = "%%" . $incl . "%%";
				
				if ($tmpl_page =~ /$incl/)
					{
					$theincl = &get_file_contents ("$data_dir/$ifilen");
					$tmpl_page =~ s/$incl/$theincl/g;
					}
				
			}
		}
	}


$tmpl_page =~ s/!build_url!/$web_url/g;
$tmpl_page =~ s/!!scripts_url!!/$script_url/g;
$tmpl_page =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;

return ($tmpl_page);

}





sub fill_vars
{

my ($filledvar) = @_;
my (@conflines, $statsetting);

$filledvar =~ s/!!scripts_url!!/$script_url/g;
$filledvar =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;
$filledvar =~ s/!build_url!/$web_url/g;
$filledvar =~ s/!!build_url!!/$web_url/g;

open (GSETT, "$data_dir/gsettings.dat");
	@conflines = <GSETT>;
close (GSETT);
$statsetting = $conflines[29];
chop($statsetting);


####
if ($statsetting =~ /dyn_stat=Dynamic/)
	{
	$filledvar =~ s/!!whatsnew!!/$script_url\/dirs\.cgi?newpop=new/g;
	$filledvar =~ s/!!tophits!!/$script_url\/dirs\.cgi?newpop=pop/g;
	}
	else
	{
	$filledvar =~ s/!!whatsnew!!/$web_url\/new\//g;
	$filledvar =~ s/!!tophits!!/$web_url\/pop\//g;
	}

$filledvar =~ s/!!modify_link_url!!/$script_url\/modify\.cgi/g;
$filledvar =~ s/!!add_url_link!!/$script_url\/addurl\.cgi/g;
$filledvar =~ s/!!add_premium_url_link!!/$script_url\/addurl\.cgi?p=1/g;
$filledvar =~ s/!!rgs_login!!/$script_url\/rgs_login\.cgi/g;
$filledvar =~ s/!!register!!/$script_url\/rgs_register\.cgi/g;
$filledvar =~ s/!!favorites_link!!/$script_url\/fav\.cgi/g;


$topvar = &get_file_contents("$data_dir/frontlink.dat");
if ($topvar eq ""){$filledvar =~ s/!!top!!/$script_url\/fp\.cgi/gi;}else{$filledvar =~ s/!!top!!/$topvar/gi;}

return ($filledvar);
}






sub decode_date
{

my ($tvalue) = @_;
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst,@marray, $rdvalue, $ampm);

($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime($tvalue);
$year = "20" . substr($year, 1, 2);
@marray = ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");

if (length($min) == 1) {$min = "0" . $min;}
if (length($min) == 1) {$min = "0" . $min;}

if ($gsettings->{date_format} == 0)
	{
	$rdvalue = "$marray[$mon] $mday, $year";
	}
	elsif ($gsettings->{date_format} == 1)
	{
	$rdvalue = "$mday $marray[$mon] $year";
	}
	elsif ($gsettings->{date_format} == 2)
	{
	$mon++;
	if (length($mday) == 1) { $mday = "0" . $mday; }
	if (length($mon) == 1) { $mon = "0" . $mon; }
	$rdvalue = "$year-$mon-$mday";
	}
	elsif ($gsettings->{date_format} == 3)
	{
	$mon++;
	if (length($mday) == 1) { $mday = "0" . $mday; }
	if (length($mon) == 1) { $mon = "0" . $mon; }
	$rdvalue = "$mon-$mday-$year";
	}
	elsif ($gsettings->{date_format} == 4)
	{
	$mon++;
	if (length($mday) == 1) { $mday = "0" . $mday; }
	if (length($mon) == 1) { $mon = "0" . $mon; }
	$rdvalue = "$mday-$mon-$year";
	}

#print "==>$dateformat $rdvalue <BR>";

return ($rdvalue);

}




sub get_rating_images
{
my ($rating) = @_;
my ($image_rate, $decm, $images);

	if ($rating > 0)
			{
			($image_rate, $decm) = split (/\./, $rating);
		
			if (length($decm) == 1)
				{
				if ($decm > 4) {$image_rate++;}
				}
			if (length($decm) == 2)
				{
				if ($decm > 49) {$image_rate++;}
				}
		
			$image_rate = "r" . $image_rate . ".gif";
			$image_rate =~ s/ //g;
			$images = "<img src=\"$web_url/$image_rate\">";
			}

return ($images);
}





sub encode_dir
{

my ($fstring) = @_;
my ($ms, $enc_string, $oneletter, $bstr);

$fstring =~ s/ /_/g;

 for ($ms = 0; $ms < length($fstring); $ms++) 
	{
	
	$oneletter = substr($fstring, $ms, 1);
	
	if (($oneletter !~ /[0-9a-zA-Z]/) and ($oneletter ne "_"))
		{
			$bstr = ord($oneletter);
			if (length($bstr) == 1) {$bstr = "00" . $bstr;}
			if (length($bstr) == 2) {$bstr = "0" . $bstr;}
			$bstr = "," . $bstr;
			$enc_string = $enc_string . $bstr;
		}
		else
		{
			$enc_string = $enc_string . $oneletter;
		}
	}

return ($enc_string);

}




sub insert_images
{
my ($ihtml, $iurl) = @_;
my ($crit);

$crit = "<img src=\""; $ihtml =~ s/\[img\]/$crit/gi;
$crit = "\">"; $ihtml =~ s/\[\/img\]/$crit/gi;
$crit = "<a href=\"$iurl\"><img src=\""; $ihtml =~ s/\[imglnk\]/$crit/gi;
$crit = "\" border=\"0\"></a>"; $ihtml =~ s/\[\/imglnk\]/$crit/gi;							

return ($ihtml);
}



sub new_gsettings
{
my $this = {};
my ($scnts, @all_obj_items, $obji, $obj_prp, $obj_val);

$scnts = &get_file_contents("$data_dir/gsettings.dat");
@all_obj_items = split (/\n/, $scnts);

foreach $obji (@all_obj_items)
	{
	($obj_prp, $obj_val) = split (/=/, $obji);
	$this->{$obj_prp} = $obj_val;
	}

bless $this;
return $this;
}




sub do_full_text_search
{

#$keywords = &get_search_ready($q->param('keywords'));
$keywords =~ s/ /+/g;

$cat_search = $q->param('cat_search');


print <<END_OF_FS;

<html>
<head>
<title>Search</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$script_url/search2.cgi?keywords=$keywords&cat_search=$cat_search">
</head>
<body>
</body>
</html>

END_OF_FS

}




sub check_search_spamming
{


$nr_searches_per_hour = $gsettings->{searches_per_hour};


### CHECK IF TMP DIR EXISTS
if ((-e "$data_dir/tmpip") < 1) 
	{
	$status = mkdir("$data_dir/tmpip", 0777);
	$stat = chmod($default_permissions,"$data_dir/tmpip","$data_dir/tmpip");
	}

### CLEAN UP tmpip DIR FOR OLDER SEARCHES

$ipaddress = $ENV{'REMOTE_ADDR'};
$ntime = time();

	opendir(DDIR,"$data_dir/tmpip");
	@afiles = readdir(DDIR);
	foreach $filenamea (@afiles)
		{
			if (($filenamea ne ".") and ($filenamea ne ".."))
			{
			($device,$inode,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat("$data_dir/tmpip/$filenamea");
				if ($mtime < ($ntime - 3600))
					{
					$stat = unlink ("$data_dir/tmpip/$filenamea");
					}
			}
		}
	closedir (DDIR);




### RECORD IP ADDRESS

if ((-e "$data_dir/tmpip/$ipaddress") < 1)
	{
	open (IPADD, "> $data_dir/tmpip/$ipaddress");
		print IPADD "1";
	close (IPADD);
	$stat = chmod($default_permissions,"$data_dir/tmpip/$ipaddress","$data_dir/tmpip/$ipaddress");
	}
	else
	{
	open (IPADD, "$data_dir/tmpip/$ipaddress");
		$ipnr = <IPADD>;
	close (IPADD);
	
	if ($ipnr >= $nr_searches_per_hour)
		{
		print "Maximum number of searches exceeded. Access denied. Please try again later."; exit;
		}
	
	$ipnr++;
	
	open (IPADD, "> $data_dir/tmpip/$ipaddress");
		print IPADD $ipnr;
	close (IPADD);
	}

}






sub get_more_info_file_name
{

my ($title_without_link, $tllid) = @_;

		$title_without_link_tmp = $title_without_link;
		
			$more_info_pg_name = ""; $title_without_link_tmp =~ s/ /_/gi;
			for ($ms = 0; $ms < length($title_without_link_tmp); $ms++) 
				{
				$oneletter1 = substr($title_without_link_tmp, $ms, 1);
					if (($oneletter1 =~ /[0-9a-zA-Z]/) or ($oneletter1 eq "_"))
					{
					$more_info_pg_name = $more_info_pg_name . $oneletter1;
					}
				}
			$more_info_pg_name = lc($more_info_pg_name);
			if (length($more_info_pg_name) > 80) { $more_info_pg_name = substr($more_info_pg_name, 0, 80); }
			$more_info_pg_name = $more_info_pg_name . "_" . $tllid;
	

return ($more_info_pg_name);

}




sub get_setup
{
my ($line, $r);

my $exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}

sub get_setup_line
{
my ($setup_line, $setup_var, $crit1, $r1, $r2, $return_val) = @_;
$crit1 = "\"";
$setup_line =~ m/$crit1/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit1/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################